//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     LimeGreen
#property indicator_color2     DarkGreen
#property indicator_color3     Red
#property indicator_color4     Maroon
#property indicator_color5     DodgerBlue
#property indicator_color6     Gold
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     2
#property indicator_width6     2
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern int    Length            = 12;
extern int    Price             = PRICE_CLOSE;
extern int    SignalPeriod      = 6;
extern int    SignalMaMethod    = MODE_LWMA;
extern bool   HistogramOnSlope  = true;
extern bool   Interpolate       = true;

extern double multiplier        = 2;
extern double levelOb           = 20.0;
extern double levelOs           = -20.0;

extern bool   alertsOn          = true;
extern bool   alertsOnSlope     = false;
extern bool   alertsOnZeroCross = true;
extern bool   alertsOnCurrent   = true;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;
extern bool   alertsPush        = false;
extern string soundFile         = "alert2.wav"; 

//
//
//
//
//

double rsxhuu[];
double rsxhud[];
double rsxhdd[];
double rsxhdu[];
double rsx[];
double rsxMa[];
double diff[];
double trend[];
double slope[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,rsxhuu); SetIndexStyle(0, DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxhud); SetIndexStyle(1, DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsxhdd); SetIndexStyle(2, DRAW_HISTOGRAM);
      SetIndexBuffer(3,rsxhdu); SetIndexStyle(3, DRAW_HISTOGRAM);
      SetIndexBuffer(4,rsx);
      SetIndexBuffer(5,rsxMa);
      SetIndexBuffer(6,diff);
      
          //
          //
          //
          //
          //
         
          timeFrame         = stringToTimeFrame(TimeFrame);
          indicatorFileName = WindowExpertName();
          returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
          calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

          //
          //
          //
          //   
          //
          
   SetLevelValue(0,levelOb);
   SetLevelValue(1,levelOs);
   SetLevelValue(2,0);
   IndicatorShortName(timeFrameToString(timeFrame)+"  Rsx SigMa Histo ("+Length+","+SignalPeriod+")");
   return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][13];

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsx[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     double Kg = (3.0)/(2.0+Length); 
     double Hg = 1.0-Kg;
     if (ArrayRange(trend,0)    !=Bars)  ArrayResize(trend,Bars);
     if (ArrayRange(slope,0)    !=Bars)  ArrayResize(slope,Bars); 
     if (ArrayRange(wrkBuffer,0)!= Bars) ArrayResize(wrkBuffer,Bars);
     for (i=limit, r=Bars-i-1; i>=0; i--, r++)
     {
        wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
        if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

        //
        //
        //
        //
        //
      
        double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
        double moa = MathAbs(mom);
        for (int k=0; k<3; k++)
        {
           int kk = k*2;
              wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
              wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
              wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
              wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
        }
        if (moa != 0)
             rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)-50; 
        else rsx[i] = 0;
      
        //
        //
        //
        //
        //
      
        }
        for (i=limit, r=Bars-i-1; i>=0; i--, r++)
        {
           rsxMa[i] = iMAOnArray(rsx,0,SignalPeriod,0,SignalMaMethod,i);
           diff[i]  = (rsx[i] - rsxMa[i]) * multiplier;
           rsxhuu[i] = EMPTY_VALUE;
           rsxhud[i] = EMPTY_VALUE;
           rsxhdd[i] = EMPTY_VALUE;
           rsxhdu[i] = EMPTY_VALUE;

           //
           //
           //
           //
           //
                           
           trend[r]  = trend[r-1];
           slope[r]  = slope[r-1];
              if (diff[i] > diff[i+1]) slope[r] = 1;
              if (diff[i] < diff[i+1]) slope[r] =-1;
              if (diff[i] > 0)         trend[r] = 1;
              if (diff[i] < 0)         trend[r] =-1;
              
              if (HistogramOnSlope)
              {
                if (trend[r] ==  1 && slope[r] ==  1) rsxhuu[i] = diff[i];
                if (trend[r] ==  1 && slope[r] == -1) rsxhud[i] = diff[i];
                if (trend[r] == -1 && slope[r] == -1) rsxhdd[i] = diff[i];
                if (trend[r] == -1 && slope[r] ==  1) rsxhdu[i] = diff[i];
              }
              else
              {                  
                if (trend[r] ==  1) rsxhuu[i] = diff[i];
                if (trend[r] == -1) rsxhdd[i] = diff[i];
              }
         }
         manageAlerts();
   return(0);
   }
        
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (ArrayRange(trend,0)!=Bars)  ArrayResize(trend,Bars);
   if (ArrayRange(slope,0)!=Bars)  ArrayResize(slope,Bars);
   for (i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rsx[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,SignalPeriod,SignalMaMethod,4,y);
         rsxMa[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,SignalPeriod,SignalMaMethod,5,y);
         diff[i]   = (rsx[i] - rsxMa[i]) * multiplier;
         rsxhuu[i] = EMPTY_VALUE;
         rsxhud[i] = EMPTY_VALUE;
         rsxhdd[i] = EMPTY_VALUE;
         rsxhdu[i] = EMPTY_VALUE;
         
         trend[r]  = trend[r-1];
         slope[r]  = slope[r-1];
            if (diff[i] > diff[i+1]) slope[r] = 1;
            if (diff[i] < diff[i+1]) slope[r] =-1;
            if (diff[i] > 0)         trend[r] = 1;
            if (diff[i] < 0)         trend[r] =-1;
            
            if (HistogramOnSlope)
            {
              if (trend[r] ==  1 && slope[r] ==  1) rsxhuu[i] = diff[i];
              if (trend[r] ==  1 && slope[r] == -1) rsxhud[i] = diff[i];
              if (trend[r] == -1 && slope[r] == -1) rsxhdd[i] = diff[i];
              if (trend[r] == -1 && slope[r] ==  1) rsxhdu[i] = diff[i];
            }
            else
            {                  
              if (trend[r] ==  1) rsxhuu[i] = diff[i];
              if (trend[r] == -1) rsxhdd[i] = diff[i];
            }
            
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int x = 1; x < n; x++)
               {
                  rsx[i+x]   = rsx[i]   + (rsx[i+n]   - rsx[i])   * x/n;
                  rsxMa[i+x] = rsxMa[i] + (rsxMa[i+n] - rsxMa[i]) * x/n;
                  diff[i+x]  = diff[i]  + (diff[i+n]  - diff[i])  * x/n;
                  if (rsxhuu[i]!=EMPTY_VALUE) rsxhuu[i+x]=diff[i+x];
                  if (rsxhud[i]!=EMPTY_VALUE) rsxhud[i+x]=diff[i+x];
                  if (rsxhdu[i]!=EMPTY_VALUE) rsxhdu[i+x]=diff[i+x];
                  if (rsxhdd[i]!=EMPTY_VALUE) rsxhdd[i+x]=diff[i+x];
               }               
   }
   manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar))-1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar-1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," sloping up");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," sloping down");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnZeroCross && trend[whichBar] != trend[whichBar-1])
         {
            if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar," crossed zero up");
            if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar," crossed zero down");
         }                    
    }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsx_SigMa ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Rsx_SigMa "),message);
             if (alertsPush)    SendNotification(StringConcatenate(Symbol(), Period() ," Rsx_SigMa " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
      }
}


